#version 330
#extension GL_EXT_gpu_shader4 : enable
//strudelMod01.fsh  by  phreax 
//https://www.shadertoy.com/view/3dc3Wr
// Licence CC0
// Adapted, trivialy, for use in VGHD player
/////////////////////////////////////////////
uniform float u_Elapsed;    // The elapsed time in seconds
uniform vec2  u_WindowSize; // Window dimensions in pixels

#define iTime u_Elapsed*0.314159  //*0.1666
#define iResolution u_WindowSize

//#define mouse AUTO_MOUSE
//#define MOUSE_SPEED vec2(vec2(0.5,0.577777) * 0.25)
//#define MOUSE_POS   vec2((1.0+cos(iTime*MOUSE_SPEED))*u_WindowSize/2.0)
//#define MOUSE_PRESS vec2(0.0,0.0)
//#define AUTO_MOUSE  vec4( MOUSE_POS, MOUSE_PRESS )
//#define RIGID_SCROLL
// alternatively use static mouse definition
#define iMouse vec4(0.0,0.0, 0.0,0.0)
//#define iMouse vec4(512,256,180,120)
uniform sampler2D iChannel0;
uniform sampler2D iChannel1;
uniform sampler2D iChannel2;
uniform sampler2D iChannel3;
vec4 texture2D_Fract(sampler2D sampler,vec2 P) {return texture2D(sampler,fract(P));}
vec4 texture2D_Fract(sampler2D sampler,vec2 P, float Bias) {return texture2D(sampler,fract(P),Bias);}
#define texture2D texture2D_Fract

#define rot(x) mat2(cos(x), sin(x), -sin(x), cos(x))

// set to true for a "fly through effect"
#define ROT_CAM true

// bend tunnel
#define BEND .8        

float spiral(vec2 uv, float i) {  
    uv *= rot(i*3.14-.4*iTime);
    uv += .03*sin(vec2(40, 70)*uv.yx);

	float d = length(uv);
    return smoothstep(1., -1., abs(d-.12)/fwidth(d)-.2);
}
void main (void)
//void mainImage( out vec4 fragColor, in vec2 fragCoord )
{
    vec2 uv = (gl_FragCoord.xy -.5*iResolution.xy)/iResolution.y;

    float col = 0.;
	
    for(float i=.02; i<=1.; i+=.02) {   
        float z = fract(i-.1*iTime);
        float fade = smoothstep(1., .8, z);
        vec2 UV = uv;
        if(ROT_CAM) {   
       	 UV += sin(vec2(.3, .6)*iTime+z*BEND)*.3;
        }
        col += spiral(UV*z, i)*(.5/z)*fade;
    }
    
    col = sqrt(col);

    gl_FragColor = vec4(vec3(col), 1.);
}